/* 

FoxSpray 0.5 by Fox-NL

### Description: ###
when you are playing, you can spray using the normal key
when you have sprayed the logo, you can teleport yourself to that
spray everytime you want, its very easy!
just say "/gospray" or bind a key to "gospray"!

### client cmd's: ###
- say /gospray - teleport to you're last spray!
- gospray - teleport to you're last spray!


### server cvar's: ###
# sv_foxspray - enable plugin?
0=disabled
1=enabled (default)

# foxspray_erase - erase saved location at newround?
0=no
1=yes (default)

# foxspray_effects - effects when teleporting?
0=no
1=yes (default)

# foxspray_freezetime - no teleporting in freezetime?
0=no
1=yes (default)

# foxspray_max - maximum teleports per round? (default=5)

### credits ###
Fox-NL for making this plugin
Nightscream(me) for translate it to dutch language
NiGHTFiRE for translate it to swedish language
trawiator for translate it to polish language
JanSky for translate it to finnish language
faluco for translate it to spanish language
[pc]Raba for translate it to german language
NiLuJe for translate it to french language

### installation: ###
- if you don't have amxx 1.1 then install it
- extract the .zip into amxmodx folder
- open plugins.ini (addons/amxmodx/configs)
- add a line containing: "foxspray.amxx"
- start the server, to extra check if the plugin is running type "amxx plugins"
in the server console...

changelog:
# 0.3 - Updated:
- added more effects (thank you Fox-NL)

# 0.2 - Updated:
- added the foxspray_max cvar (thank you Fox-NL)
- added freezetime cvar (thank you Fox-NL)

# 0.1 - made first version (thank you Fox-NL)

amxx changelog:
# 0.5 - Updated:
- added more effects (amx plugin [thank you Fox-NL] )
- added spanish language (thank you faluco)
- added german language (thank you [pc]Raba)
- added french language (thank you NiLuJe)

# 0.4 - Updated:
- added finnish language (thank you JanSky)

# 0.3 - Updated:
- added swedish language (thank you NiGHTFiRE)
- added polish language (thank you trawiator)

# 0.2 - Updated:
- added dutch language (thank you nightscream[me] )

# 0.1 - Ported over to amxx (thank you nightscream[me] )

*/

#include <amxmodx>
#include <fun>

new sprayloc[33][6]
new savedoldloc[33][3]
new g_lastPosition[3]
new tele_sprite
new fs_count[33]
new bool:fs_using[33]
new bool:freezetime
new gmsgSayText
new blueflare

public plugin_init() {
	register_plugin("FoxSpray","0.5","Fox-NL")
	register_dictionary("foxspray.txt")
	register_event("23", "newspray", "a", "1=112")
	register_event("ResetHUD", "resethud_event", "be")
	register_event("RoundTime","event_roundtime","bc")
	register_logevent("event_roundstart", 2, "0=World triggered", "1=Round_Start")
	register_logevent("event_roundend", 2, "0=World triggered", "1=Round_End")
	register_clcmd("say /gospray","foxspray")
	register_clcmd("gospray","foxspray")
	register_cvar("sv_foxspray","1") // enable FoxSpray?
	register_cvar("foxspray_erase","1") // erase at resethud?
	register_cvar("foxspray_effects","1") // effects when teleporting?
	register_cvar("foxspray_max","5") // maximum per round?
	register_cvar("foxspray_freezetime","1") // no gospray during freezetime?
	server_print("[FoxSpray] plugin loaded succesfully.")
	gmsgSayText = get_user_msgid("SayText")
}

public event_roundtime() if(get_cvar_num("mp_freezetime") == read_data(1)) freezetime=true
public event_roundstart() freezetime=false
public event_roundend() freezetime=false

public plugin_precache() {
	tele_sprite = precache_model("sprites/shockwave.spr")
	blueflare = precache_model("sprites/xspark4.spr")
}

public resethud_event(id) {
	if(get_cvar_num("foxspray_erase")==1) clear_spray(id,1)
	else clear_spray(id,0)
}

public client_authorized(id) clear_spray(id,1)
public client_disconnect(id) clear_spray(id,1)

stock clear_spray(id,erase=1) {
	fs_count[id]=0
	fs_using[id]=false
	if(erase==1) {
		sprayloc[id][0] = 0
		sprayloc[id][1] = 0
		sprayloc[id][2] = 0
	}
}

public newspray() {
	if(get_cvar_num("sv_foxspray")==1) {
		new id = read_data(2), origin[3]
		get_user_origin(id,origin)
		sprayloc[id][0] = read_data(3)
		sprayloc[id][1] = read_data(4)
		sprayloc[id][2] = read_data(5)
		sprayloc[id][3] = origin[0]
		sprayloc[id][4] = origin[1]
		sprayloc[id][5] = origin[2]
	}
	return PLUGIN_HANDLED
}

public foxspray(id) {
	if(get_cvar_num("sv_foxspray")==0) {
		client_print(id,print_center,"%L",id,"command_disable")
		return PLUGIN_HANDLED
	}
	if((sprayloc[id][0]==0 && sprayloc[id][1]==0 && sprayloc[id][2]==0)||(sprayloc[id][0]==0 && sprayloc[id][1]==0 && sprayloc[id][2]==0)) {
		client_print(id,print_center,"%L",id,"no_save_location")
		return PLUGIN_HANDLED
	}
	if(freezetime && get_cvar_num("foxspray_freezetime")==1) {
		client_print(id,print_center,"%L",id,"no_teleport_freeze")
		return PLUGIN_HANDLED
	}
	if(fs_using[id]) {
		client_print(id,print_center,"%L",id,"teleport_using")
		return PLUGIN_HANDLED
	}
	new cvar_max = get_cvar_num("foxspray_max")
	if(fs_count[id] >= cvar_max) {
		client_print(id,print_center,"%L",id,"teleport_max", cvar_max)
		return PLUGIN_HANDLED
	}
	fs_count[id]++
	new oldlocation[3], newlocation[3], parm[3]
	get_user_origin(id, oldlocation)
	oldlocation[2]+=30
	savedoldloc[id]=oldlocation
	newlocation[0]=sprayloc[id][0]
	newlocation[1]=sprayloc[id][1]
	newlocation[2]=(sprayloc[id][2] + 40)
	set_user_origin(id,newlocation)
	g_lastPosition[0]=newlocation[0]
	g_lastPosition[1]=newlocation[1]
	g_lastPosition[2]=newlocation[2]
	if(get_cvar_num("foxspray_effects")==1) {
		message_begin(5,23,oldlocation)
		write_byte(21)
		write_coord(oldlocation[0])
		write_coord(oldlocation[1])
		write_coord(oldlocation[2]+10)
		write_coord(oldlocation[0])
		write_coord(oldlocation[1])
		write_coord(oldlocation[2]+60)
		write_short(tele_sprite)
		write_byte(0)
		write_byte(0)
		write_byte(3)
		write_byte(60)
		write_byte(0)
		write_byte(255)
		write_byte(255)
		write_byte(255)
		write_byte(255)
		write_byte(0)
		message_end()
		message_begin(1,98,{0,0,0},id)
		write_short(1<<12)
		write_short(1<<8)
		write_short(1<<1)
		write_byte(76)
		write_byte(163)
		write_byte(223)
		write_byte(200)
		message_end()
	}
	parm[0]=id
	parm[1]=1
	remove_task(id,0)
	set_task(0.1,"positionChangeCheck",0,parm,2)
	fs_using[id]=true
	return PLUGIN_HANDLED
}

public positionChangeCheck(parm[2]) {
	new id=parm[0], type=parm[1], origin[3]
	if(!is_user_alive(id)) {
		fs_count[id]--
		fs_using[id]=false
		return
	}
	get_user_origin(id, origin, 0)
	if(g_lastPosition[0]==origin[0]&&g_lastPosition[1]==origin[1]&&g_lastPosition[2]==origin[2]) {
		if(type==1) {
			new newlocation[3], parm2[2]
			newlocation[0] = sprayloc[id][3]
			newlocation[1] = sprayloc[id][4]
			newlocation[2] = sprayloc[id][5]+10
			set_user_origin(id,newlocation)
			parm2[0]=id
			parm2[1]=2
			remove_task(id,0)
			set_task(0.1,"positionChangeCheck",0,parm2,2)
			return
		} else {
			set_user_origin(id, savedoldloc[id])
			client_print(id,print_center,"%L",id,"no_good_spray_spot")
			fs_count[id]--
			fs_using[id]=false
			return
		}
	}
	if(get_cvar_num("foxspray_effects")==1) {
		new location[3]
		get_user_origin(id,location)
		message_begin(5,23,location)
		write_byte(21)
		write_coord(location[0])
		write_coord(location[1])
		write_coord(location[2]+10)
		write_coord(location[0])
		write_coord(location[1])
		write_coord(location[2]+60)
		write_short(tele_sprite)
		write_byte(0)
		write_byte(0)
		write_byte(3)
		write_byte(60)
		write_byte(0)
		write_byte(255)
		write_byte(255)
		write_byte(255)
		write_byte(255)
		write_byte(0)
		message_end()
		message_begin(0,23)
		write_byte(15)
		write_coord(location[0])
		write_coord(location[1])
		write_coord(location[2]+40)
		write_coord(location[0])
		write_coord(location[1])
		write_coord(location[2])
		write_short(blueflare)
		write_byte(30)
		write_byte(10)
		write_byte(1)
		write_byte(50)
		write_byte(10)
		message_end()
	}
	fs_using[id]=false
	return
}

public showsay(id,msg[]) {
	message_begin(1, gmsgSayText, {0,0,0}, id)
	write_byte(id)
	write_string(msg)
	message_end()
}